/* Command Line Interface
 *
 *
 *
 */

#include "cli.h"

char uartbuf[80];
char command[80];
char message[80];
uint8_t ui_cmd_ready;
uint8_t ui_uart_rx_pointer;


void uart_init(void)
{
    /* 115200 BPS at 20MHz systemclock*/
    #define UBRR 10
    /* Baudrate setzen */
    UBRR0H = HI8(UBRR) ;
    UBRR0L = LO8(UBRR) ;
    /* Enable receiver and transmitter */
    UCSR0B = _BV(RXEN0) | _BV(TXEN0) ;
    /* Set data format 8 DataBits 2 StopBits */
    UCSR0C = _BV(USBS0) | _BV(UCSZ00) | _BV(UCSZ01);
    /* enable receive interrupt */
    UCSR0B |= _BV(RXCIE0) ;
}

void debug_output(char *msg)
{
  char *i ;
  i = msg ;

  while(*i > 0)
  {
    uart_sendbyte(*i) ;
    i++;
  }
}

void uart_sendbyte(char data)
{
    /* wait till tx buffer is empty */
    while ( ! (UCSR0A  & _BV(UDRE0)) )
    {}
    /* send byte */
    UDR0 = data;
}

void ui_display(void)
{
    //ansi_cls();
    //ansi_color(7,4);
    ansi_locate(1,1);
    debug_printf("CMD: %s          ",command);
    ansi_locate(2,1);
    debug_printf("Message: %s          ",message);
}

/* ANSI Funktionen */
/* Diese Funktion loescht den Bildschirm */
void ansi_cls(void)
{
    debug_printf("%c[2J",27);
    ansi_locate(1,1);
}

/* Diese Funktion setzen den cursor an die angegebene Position */
void ansi_locate(int x, int y)
{
    debug_printf("%c[%d;%dH",27,x,y);
}

/* Diese Funktion setzt vordergrund und Hintergrund Farbe
 * 0=Black 1=red 2=green 3=yellow 4=blue 5=mangenta 6=cyan 7=white
 */
void ansi_color(int fg, int bg)
{
    fg = fg + 30 ;
    bg = bg + 40 ;

    debug_printf("%c[%d;%dm",27,fg,bg) ;
}

/* Wird nicht benutzt, stattdessen in jackalope.c */
void process_cli_command(void)
{
    ui_cmd_ready = 0;
    ui_uart_rx_pointer = 0;
    char cmd[40];
    cmd[0] = 0x00;
    uint32_t value1;
    uint32_t value2;
    uint8_t argcnt;

    argcnt = sscanf_P(command,PSTR("%s %ld %ld"),cmd,&value1,&value2);

    // demo command
    if ( strncmp_P(command,PSTR("test"),4) == 0 && argcnt == 1)
    {
        strcpy_P(message,PSTR("test ok"));
    }
    else if ( strncmp_P(command,PSTR("out"),3) == 0 && argcnt == 3)
    {
        sprintf_P(message,PSTR("CMD: out Relais: %ld Wert: %ld"),value1,value2);
        DDRD |=  _BV(value1+1);
        if ( value2 == 1)
        {
            PORTD |= _BV(value1+1);
        }
        else if (value2 == 0)
        {
            PORTD &= ~_BV(value1+1);
        }
        else
        {
            strcpy_P(message,PSTR("Ungueltiger Parameter"));
        }
    }
    else if ( strncmp_P(command,PSTR("in"),2) == 0 && argcnt == 2)
    {
        DDRD &=  ~_BV(value1+1);
        value2 = PIND & _BV(value1+1) / (_BV(value1+1));

        sprintf_P(message,PSTR("CMD: in Port: %ld Wert: %ld"),value1,value2);
    }
    else
    {
        strcpy_P(message,PSTR("Kommando unbekannt"));
    }
    // Kommando lschen
    command[0] = 0x00;
    ansi_cls();
}
