1;
# Main Programm, send a command to the jackalope and fetch the result
sub get_cmd_result
{
    my($cmd) = @_;
    my($data,$v1,$v2,$v3,$v4,$err,$errtxt);

    $PortObj->write("$cmd\n");
    $data = &read_data();
    $data = extract_json($data);
    if ( length($data) > 0 )
    {
        $data = decode_json($data);

        $v1 = $data->{'value1'};
        $v2 = $data->{'value2'};
        $v3 = $data->{'value3'};
        $v4 = $data->{'value4'};

        $err = $data->{'error'};
        $errtxt = $data->{'errortext'};
    }

($v1,$v2,$v3,$v4,$err,$errtxt);
}

sub open_port
{
    my($port) = @_;
    $PortObj = Device::SerialPort->new($port);
    $PortObj->baudrate(115200);
    $PortObj->parity("none");
    $PortObj->databits(8);
    $PortObj->stopbits(1);
    $PortObj->handshake("none");

    return $PortObj;
}

sub read_data
{
    my($in,$no_data_cnt);
    $in = "";
    do
    {
        my($count_in, $string_in) = $PortObj->read(200);
        $in .= $string_in;

        #print "IN: $string_in";

        if ($count_in == 0)
        { $no_data_cnt++; select(undef,undef,undef,0.2); }
        else
        { $no_data_cnt = 0; }

        #print "Habe $count_in bytes gelesen\n";
        #print "Daten: $string_in\n";
    #} while ($count_in > 0 && $no_data_cnt < 5);
    } while (index($in,"}\r\n") == -1 && $no_data_cnt < 15);

    if ($no_data_cnt == 15)
    { $failCount++;}
    else
    { $failCount = 0;}

    #print "FAIL: $failCount\n";

    $in =~ s/\r//g;
#    $in =~ s/\n/ /g;

    #print "Empfangen: $in\n";

    return $in;
}


# Find starting and closing bracket
sub extract_json
{
    my($data) = @_;
    $p1 = index($data,"{");
    $p2 = rindex($data,"}");

    if ($p1 > -1 && $p2 > -1)
    {
        $data = substr($data,$p1,($p2-$p1)+1);
    }
    else
    {
        $data = "";
    }
    return $data;
}


sub jackalope_init
{

    my($wert1,$wert2,$wert3,$wert4,$error,$errortxt) = get_cmd_result("XXX");

    if ($wert1 == 111 && $wert2 == 222 && $wert3 == 333 && $wert4 == 444)
    {
        return 0;
    }
    else
    {

    # Try again
    my($cnt);
    $cnt = 0;
    do
    {
       $cnt++;
       # Müll der schnittstelle beseitigen
       print &read_data();

        # JSON encoding
        $PortObj->write("json 1\n");
        &read_data();

       ($wert1,$wert2,$wert3,$wert4,$error,$errortxt) = get_cmd_result("XXX");

    }
    while ($wert1 != 111 && $wert2 != 222 && $wert3 != 333 && $wert4 != 444 && $cnt < 10);

    if ($cnt == 10)
    {
       return -1;
    }
    else
    {
       return 0;
    }

    }
}
