#ifndef JACKALOPE_H
#define JACKALOPE_H

#include <stdint.h>

#define MAJOR_VERSION 1
#define MINOR_VERSION 8

// Always turn both (RFM12 OR RFM69) AND FNORD_NET on or off
#define FNORD_NET_ENABLE 1 // 1
#define RFM12_ENABLE 0 // 0
#define RFM69_ENABLE 1 // 1
#define RFM69_OOK 1 // 1
#define RFM69_OOKMODE 2 // 1= Using Delay Loop 2= Using FIFO Wert: 2
#define RFM69_OOK_CAPTURE 0 // 0
#define RFM69_DEBUG_CMDS 0 // 0

#define EEPROM_DEBUG_CMDS 0

// Algo Version of the buildin Solar Panel Regulator - For test purposes only
#define SOLAR_REGULATOR_VERSION 0 // 2

// Wie oft hintereinander darf die fnord_check_collision routine das senden unterbinden
// bis das Modul resettet wird RX->standby und standby->RX modus wechsel
#define FNORD_MAX_COLLISION_COUNT 100

// enable help command for explanation of all commands
#define HELP_ENABLE 1

#define ANSI_DISPLAY_ENABLE 0

#define FNORD_NET_BASIC_DEBUG 0 // 0
#define FNORD_NET_DEBUG 0  // 0
#define FNORD_NET_DEBUG_DATA 0 // 0

// enable DHT11 / DHT22 temp sensor
#define DHT11_ENABLE 1

#define HI8(x)  ((uint8_t)((x) >> 8))
#define LO8(x)  ((uint8_t)(x))

// Wird im Makefile gesetzt
#ifdef DEBUG
    #define  debug_printf(s, args...) sprintf_P(uartbuf,PSTR(s), ## args) ; serial_output(uartbuf);
#else
    #define debug_printf(...)
#endif

#define out_printf(s, args...)  sprintf_P(uartbuf,PSTR(s), ## args) ; serial_output(uartbuf)

/* command struktur
 * Struktur der Daten die an eine Funktion uebergeben werden die ein Kommando ausfuehrt
 * z.B. cmd_test
 */
struct cmd_data_t
{
    union
    {
        uint8_t raw[12];
        struct
        {
            uint8_t remote_addr;
            uint8_t cmd_id;
            uint8_t sub_command;
            int16_t value[4];
            uint8_t err;
        };
    };
};

struct cmd_data_t cmd_data;

void uart_init(void);
void uart_sendbyte(char data);
void serial_output(char *);
void ui_display(void);
void process_cli_command(void);
uint8_t spi_transfer_byte(uint8_t);

void exec_internal_programm(void);

void ansi_cls(void);
void ansi_locate(int,int);
void ansi_color(int,int);

//extern char uartbuf[70];

extern int __heap_start, *__brkval;

char uartbuf[90];

#endif /* ende JACKALOPE_H */
