#include <stdint.h>

/* Variablen RFM12 */
#define RFM12_RX_BUFLEN 26
#define RFM12_TX_BUFLEN 26
#define RSSI_SCAN 0

/* Prototypen RFM12 */
void rfm12_init(void);
uint8_t rfm12_check_presence(void);
uint16_t rfm12_getstatus(void);
void rfm12_setbaudrate(uint16_t);
void rfm12_setfrequency(uint16_t);
int16_t rfm12_settxpower(uint8_t);
void rfm12_tx_bytestream(uint8_t *,uint8_t);
int8_t rfm12_min_rssi(uint16_t);
void rfm12_setchannel(uint8_t);
void rfm12_setrssi(uint8_t);

// Wird aufgerufen wenn das RFM12 einen Hardwareinterrupt
// ausgeloest hat, muss im Hauptprogramm implementiert werden
// als ISR(<xxx>_vect)
void rfm12_interrupt_routine(void);

// This function is called when a frame was received from
// a datasource and needs to be processes e.g. passed to fnord-net protocol
// Needs to be implemented by the user
// Parameters: Pointer to Databuffer, raw datalen
// raw datalen might be equal to RFM12_RX_BUFLEN bug in RFM12 which never stops receiving data once started
void rfm12_received_frame(uint8_t *,uint8_t);

uint8_t rfm12_getrxlen(void);
uint8_t *rfm12_getrxpointer(void);

// Get debug info for IRQ count
uint32_t rfm12_get_irqcount(void);


#if RSSI_SCAN == 1
void rfm12_rssi_scan(uint16_t);
#endif

