#include <stdint.h>

/* Variablen RFM69 */
#define RSSI_SCAN 1
#define SPI_CMD_DEBUG 0
/* Variablen RFM12 */
#define RFM69_RX_BUFLEN 25
#define RFM69_TX_BUFLEN 25

volatile uint8_t rfm_mode; // Status are we in rx=0 or tx=1 mode standby=2

/* Prototypen RFM69 */
void rfm69_init(void);
uint8_t rfm69_sendcmd(uint8_t, uint8_t, uint8_t);
uint8_t rfm69_getreg(uint8_t);
uint8_t rfm69_setreg(uint8_t, uint8_t);
uint8_t rfm69_setregmask(uint8_t addr,uint8_t mask,  uint8_t data);

void rfm69_write_fifo(uint8_t *, uint8_t);
void rfm69_read_fifo(uint8_t *, uint8_t);

void rfm69_setbaudrate(uint16_t);
int16_t rfm69_settxpower(uint8_t);
void rfm69_setdeviation(uint8_t);
void rfm69_setfrequency(uint32_t);
void rfm69_setchannel(uint8_t);
void rfm69_setrxbw(uint16_t);
void rfm69_setrssi(uint8_t);
void rfm69_setmodulation(uint8_t);
void rfm69_setmode(uint8_t);
void rfm69_rc_calibration(void);
void rfm69_tx_bytestream(uint8_t *,uint8_t);
void rfm69_set_rxtx_mode(uint8_t);
uint32_t rfm69_get_irqcount(void);
uint8_t rfm69_get_chiprevision(void);

/* TODO
uint16_t rfm69_getstatus(void);
*/

uint8_t rfm69_getrssi(void);

#if RSSI_SCAN == 1
uint8_t rfm69_min_rssi(int16_t, int16_t *, int16_t *);
//uint8_t rfm69_rssi_scan(uint16_t);
#endif

// Wird aufgerufen wenn das RFM12 einen Hardwareinterrupt
// ausgeloest hat, muss im Hauptprogramm implementiert werden
// als ISR(<xxx>_vect)
void rfm69_interrupt_routine(void);

// This function is called when a frame was received from
// a datasource and needs to be processes e.g. passed to fnord-net protocol
// Needs to be implemented by the user
// Parameters: Pointer to Databuffer, raw datalen
void rfm69_received_frame(uint8_t *,uint8_t);

//uint8_t rfm12_getrxlen(void);
//uint8_t *rfm12_getrxpointer(void);

// Get debug info for IRQ count
//uint32_t rfm69_get_irqcount(void);

